#
# spec file for package iprutils (Version 2.2.9)
#
# Copyright (c) 2008 SUSE LINUX Products GmbH, Nuernberg, Germany.
# This file and all modifications and additions to the pristine
# package are under the same license as the package itself.
#
# Please submit bugfixes or comments via http://bugs.opensuse.org/
#

# norootforbuild
# usedforbuild    aaa_base acl attr audit-libs autoconf automake bash bind-libs bind-utils binutils bison bzip2 coreutils cpio cpp cracklib cvs cyrus-sasl db diffutils e2fsprogs file filesystem fillup findutils flex gawk gcc gdbm gdbm-devel gettext gettext-devel glibc glibc-devel glibc-locale gpm grep groff gzip info insserv klogd less libacl libattr libcom_err libgcc libgssapi libmudflap libnscd libstdc++ libtool libxcrypt libzio m4 make man mktemp module-init-tools ncurses ncurses-devel net-tools netcfg openldap2-client openssl pam pam-modules patch pciutils-devel perl permissions popt procinfo procps psmisc pwdutils rcs readline rpm sed strace sysfsutils sysvinit tar tcpd texinfo timezone unzip util-linux vim zlib zlib-devel


Name:           iprutils
BuildRequires:  ncurses-devel pciutils-devel sysfsutils
Summary:        Utilities for the IBM Power Linux RAID Adapters
Version:        2.2.9
Release:        1.2
License:        Other uncritical OpenSource License
Url:            http://sourceforge.net/projects/iprdd/
Group:          Hardware/Other
PreReq:         %insserv_prereq %fillup_prereq
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
ExclusiveArch:  %ix86 x86_64 ia64 ppc ppc64 %arm
Source0:        iprutils-%{version}-src.tar.bz2
Patch0:         iprconfig.usr-sbin.patch
Patch1:         iprutils.install-man.patch
Patch2:         iprutils.runlevel.patch

%description
Provides a suite of utilities to manage and configure SCSI devices
supported by the ipr SCSI storage device driver.



Authors:
--------
    Brian King @ IBM

%debug_package
%prep
%setup -q -n iprutils
%patch0 -p1
%patch1 -p1
%patch2 -p1

%build
make %{?jobs:-j%jobs} CFLAGS="$RPM_OPT_FLAGS \$(IPR_DEFINES)"

%install
make INSTALL_MOD_PATH=$RPM_BUILD_ROOT install
install -d $RPM_BUILD_ROOT/etc/init.d
install init.d/iprdump $RPM_BUILD_ROOT/etc/init.d/iprdump
install init.d/iprinit $RPM_BUILD_ROOT/etc/init.d/iprinit
install init.d/iprupdate $RPM_BUILD_ROOT/etc/init.d/iprupdate
%if %sles_version == 9
mv $RPM_BUILD_ROOT/usr/sbin/iprconfig $RPM_BUILD_ROOT/sbin/iprconfig
%endif

%clean
rm -rf $RPM_BUILD_ROOT
%ifarch ppc ppc64

%post
%{fillup_and_insserv -y iprdump iprinit iprupdate}
%endif

%preun
%stop_on_removal

%postun
%{insserv_cleanup}

%files
%defattr(-,root,root,-)
%doc README LICENSE
%attr(755,root,root) /sbin/*
%if %suse_version > 910
%attr(755,root,root) /usr/sbin/*
%endif
%{_mandir}/man*/*
%attr(755,root,root) /etc/init.d/*

%changelog
* Mon Apr 21 2008 - olh@suse.de
- add fillup_prereq
* Mon Apr 21 2008 - olh@suse.de
- update iprutils to version 2.2.9 (bnc#375379 - LTC43583)
  Do not save preferred primary attribute to fix an infinite failover
  problem in HA two system RAID configuration.
* Mon Nov 05 2007 - sassmann@suse.de
- fix init script dependencies
* Tue Oct 23 2007 - sassmann@suse.de
- update iprutils to version 2.2.8 (fate #302728)
  Update iprutil to support the PCI-E SAS RAID and non-RAID
  adapters on power6
* Wed Jun 20 2007 - olh@suse.de
- update to version 2.2.6 (141618 – LTC20388)
  Fix iprinit dual initiator failover device rescanning code.
  Add iprha init.d script to enable/disable primary adapter mode
  for dual initiator configs.
  Add adapter config option in iprconfig for setting primary/secondary
  adapter in dual adapter environment.
  Add iprconfig option to display SAS dual pathing information.
  Increase time waiting for new devices to show up in
  iprconfig when doing concurrent add.
  Add filename date to microcode download screen. (Ryan Hong)
  Fix to prevent unnecessarily writing sysfs attributes. (Ryan Hong)
  Return standard error code according to send_dev_init() return code.
  Fix incorrect memory free in analyze log menus.
* Thu Mar 29 2007 - olh@suse.de
- add ncurses-devel to buildrequires
* Sun Feb 04 2007 - olh@suse.de
- update to version 2.2.4
  Fix send diagnostics buffer transfer length to be only what was
  received in the receive diagnostics. Fixes disk hotplug on
  some SAS disk enclosures.
  Sourceforge patch 1627673: iprutils fix to buffer overflow
  Add checking to iprconfig command "set-qdepth" input queue
  depth value. If the given value is larger than 255, fail the command.
  Fix a bug in which the iprconfig command "raid-create"
  may create an illegal queue depth value to the ipr
  config file.
  Sourceforge patch 1627672: iprutils fix to buffer overflow
  Fix a bug in which the iprconfig command "raid-create"
  may create an illegal queue depth value to the ipr
  config file.
  Fixes for SES microcode download on SAS.
  Change to handle UA responses in the JBOD iprinit sequence.
  Fix segfault in iprconfig if /var/log does not exist.
  Allow IOA microcode download to a secondary IOA.
  Fix to prevent errors during SAS SES microcode download.
  Add a couple utility functions for SAS
  ipr_query_sas_expander_info
  ipr_query_res_redundancy_info
* Thu Dec 07 2006 - olh@suse.de
- fix comparison with string literal warning (226402)
* Wed Nov 15 2006 - olh@suse.de
- update to version 2.2.3 (218770 - LTC28528 - FATE301562)
  Fix SAS disk hotplug dual path bug.
  Change default QERR setting for SAS to 0.
* Fri Nov 10 2006 - olh@suse.de
- fix man page permissions
* Fri Sep 22 2006 - olh@suse.de
- update to version 2.2.3
  Fix iprconfig set-format-timeout.
  Reduce default JBOD queue depth to 3.
  Fix iprconfig -c set-bus-speed.
  Fix a race condition with hotplug events which could
  cause the ipr daemons to run before newly added devices
  are completed added to the system.
  Fix a segfault in iprdbg when using the macro function
* Tue Aug 15 2006 - olh@suse.de
- update to version 2.2.0
  Fix for command line SES microcode update.
  Use IOA's default format timeout for AF DASD instead
  of using a hard coded default.
  Add support to iprinit for it to handle disks going
  from JBOD <-> AF format across an adapter reset. When this
  is detected, iprinit will now attempt to delete the disk
  and then rescan that slot.
  Fixed an ncurses screen drawing bug which resulted in the
  screen getting paged down if the cursor was on the last item
  on the screen and 't' was pressed to toggle the display.
  Added disk concurrent maintenance support for handling
  dual pathed SAS disks.
  Improve iprdbg's logging
  Print better status for devices when IOA is offline/dead.
* Wed Jul 19 2006 - olh@suse.de
- update to version 2.1.5
  Fix to allow for compiling with libsysfs 2.0.0
  Remove RAID support for some older drives that should never
  have been supported.
* Tue Mar 14 2006 - olh@suse.de
- update to version 2.1.4 (#153800 - LTC22056)
  Concurrent maintenance fix for certain iSeries
  enclosures which would result in non existent
  drive slots being displayed in iprconfig.
  Remove some redundant code in disk hotplug path
  Fixup status of RAID 10 arrays to print a better status
  under multiple failure scenarios.
* Tue Feb 28 2006 - olh@suse.de
- update to version 2.1.3 (#153800 - LTC22056)
  Prevent duplicate mode sense commands from being issued.
  More uevent handling improvements.
  Automatically create hotplug directory if it doesn't
  already exist so adapter microcode update works.
  Improve robustness of uevents failure handling. Fall
  back to polling method if needed.
  Auxiliary cache adapter fixes.
  Fix iprconfig -c update-ucode to properly report an
  error if the wrong microcode level is specified.
  Fixed a compiler issue.
  Fixed a bug in iprconfig query-raid-create that prevented
  JBOD candidates from being displayed if there were no
  AF candidates as well.
* Wed Jan 25 2006 - mls@suse.de
- converted neededforbuild to BuildRequires
* Tue Jan 10 2006 - olh@suse.de
- update to version 2.1.2 (#142149 - LTC20569)
  Make iprupdate return success/failure indication when invoked with --force.
  Concurrent maintenance fix for 7031-D24/T24.
* Tue Dec 20 2005 - olh@suse.de
- update to version 2.1.1 (#140106 - LTC20386)
  Fix compile error in iprconfig
* Mon Dec 19 2005 - olh@suse.de
- update to version 2.1.0 (#140106 - LTC20386)
  - Updates for aux cache IOAs
  - Updates for SAS adapters
  - Misc fixes for new iprconfig command line options
  - Add command line options to iprconfig to perform virtually
  every iprconfig function available in the ncurses interface.
* Thu Nov 17 2005 - olh@suse.de
- update to version 2.0.15.6 (#134205 - LTC19786)
 - Fix concurrent maintenance with disk drawers reporting
  multiple SES devices on the same SCSI bus.
* Tue Nov 15 2005 - uli@suse.de
- enabled for ARM
* Wed Oct 19 2005 - olh@suse.de
- update to version 2.0.15.5 (#129140 - LTC19043)
 - Don't show enclosures in list of devices to remove in
  concurrent remove screens of iprconfig.
 - Fix concurrent disk remove function in iprconfig for
  certain disk enclosures.
 - Fix string length calculation in ipr_get_hotplug_dir
* Mon Sep 05 2005 - olh@suse.de
- keep iprconfig in /sbin in SLES9 builds
* Mon Sep 05 2005 - olh@suse.de
- update to version 2.0.15.4
  correct fix for a couple of uninitialized variable compile errors
* Sat Aug 20 2005 - olh@suse.de
- update to version 2.0.15.3 (#105892 - LTC17555)
  Fix: iprconfig: IOA microcode update would leave AF DASD
  (disks that are in disk arrays) in a state where they were
  no longer tagged queueing. Fix iprconfig to run iprinit on the
  adapter after a microcode download to ensure all attached devices
  are properly setup after a microcode download.
  Fix iprinit: If an IOA was reset for some reason at runtime,
  this would cause AF DASD devices to get tagged queueing turned
  off and it would never get turned back on. Change iprinit to
  detect this and turn tagged queueing back on if this happens.
  Changing the queue depth for a disk array was broken. Fix iprinit
  to properly restore the queue depth from the ipr configuration file.
  Fix iprconfig to handle disk format failures better
  Fix potential iprutils segfaults when iterating over disk arrays
  Fix: iprconfig: Concurrent remove/add of disks would display
  the same slot multiple times on some hardware due to SES devices
  returning bogus data. Work around this by only not showing duplicate
  slots.
  Fix: iprconfig: including a disk to a RAID 5 array when multiple
  RAID 5 arrays were attached would sometimes cause the disk
  to get included into the wrong array.
* Fri Jul 01 2005 - olh@suse.de
- fix uninitalized variables, use RPM_OPT_FLAGS
* Fri Jun 24 2005 - olh@suse.de
- iprconfig links agains libs in /usr, move it to /usr/sbin
* Mon Jun 13 2005 - olh@suse.de
- sysfsutils was split from udev
* Thu Jun 02 2005 - olh@suse.de
- update to version 2.0.15.1 (#86744 - LTC16252)
  Fix iprconfig Analyze Log options
* Fri May 20 2005 - olh@suse.de
- update to version 2.0.15 (#84694 - LTC16058)
  Clarify format options
  Setup mode page 0 for IBM drives to ensure command aging is
  enabled. This ensures commands are not starved on some drives.
  Fix so that iprdump properly names dump files once 100 dumps
  have been made.
  Make iprconfig handle failures of scsi disk formats better
  Fix iprconfig Set root kernel message log directory menu
  Properly display RAID level on all iprconfig screens
  Don't disable init.d daemons on an rpm -U
  Add ability to force RAID consistency check
* Fri Apr 15 2005 - pkirsch@suse.de
- update to version 2.0.14.2 (#77450 - LTC15108)
  Fixed bug preventing disk microcode update from working.
  Removed mention of primary/secondary adapters in some error
  screens since multi-initiator RAID is not supported and the
  messages will just cause confusion.
  iprconfig: During disk hotplug, wait for sd devices to show
  up. Fixes errors getting logged by iprconfig during hotplug.
  iprconfig: Fix cancel path on concurrent add/remove of disks
  Don't display current bus width and speed for SAS disks
  Fix scoping bug caught by gcc 4.0.
  Stop iprupdate from continually logging errors for adapters with
  backlevel adapter firmware.
* Tue Mar 22 2005 - olh@suse.de
- remove requirement from libcap
* Sun Mar 20 2005 - olh@suse.de
- update to version 2.0.14 (#72125 - LTC14443)
  Add support for non-interactive array creation and deletion through
  iprconfig.
  Use kobject_uevent notifications instead of polling if the kernel
  supports it.
  Fix iprconfig to set the actual queue depth for advanced function disks
  Allow user to force tagged queuing on to drives that do not support
  QERR=1.
  iprconfig: Download microcode. Fix blank screen when displaying
  lots of microcode images.
  Add "known to be zeroed" tracking to iprconfig to drastically reduce the
  time required to create a RAID array when starting with 512 formatted disks
  Add ability to query multi-adapter status for dual initiator RAID configs
  Add ability to set "preferred primary" adapter when running dual initiator RAID configs
  Add iprconfig screen to display dual adapter status for dual initiator RAID configs
  Prevent RAID configuration from occurring on "secondary" adapter in dual initiator RAID configs
  Use /dev/sd for SG_IO instead of /dev/sg when possible
  Set QERR=3 rather than 1 for multi-initiator configurations
  Set TST=1 for multi-initiator configurations
  Allow Format device for JBOD function to work for JBOD adapters
  Fix handling of dead adapters in all of iprutils.
* Sun Feb 27 2005 - olh@suse.de
- update to version 2.0.13.7 (#63874 - LTC12818)
  Fix to support multiple firmware dirs in /etc/hotplug/firmware.agent
  Fix use of uninitialized variable in iprconfig.
  Fix handling of medium format corrupt drives for drives
  that return NOT_READY instead of MEDIUM_ERROR.
  Fix iprconfig RAID start bug for systems with multiple RAID adapters.
  Fix iprconfig RAID include bug for systems with multiple RAID adapters.
  Fix failing array add device due to race condition with iprinit.
  Fix iprconfig microcode download to ipr adapters.
* Tue Oct 26 2004 - olh@suse.de
- update to version 2.0.13.1 (#47633 - LTC12054)
  Fix iprinit to wait for scsi generic devices to show up in case
  we are racing with hotplug. Fixes the following error:
  0:255:0:0: Mode Sense failed. rc=1, SK: 5 ASC: 24 ASCQ: 0
* Mon Oct 11 2004 - olh@suse.de
- update to version 2.0.13 (#47039 - LTC11719)
  - Improve iprupdate error logs to indicate where to download microcode from.
  - Set default tcq queue depth for AS400 disks to 16.
  - Don't log errors in iprdump if CONFIG_IPR_DUMP not enabled in the kernel
  - Fix sysfs parsing to handle new sdev target kernel change
  - Rescan JBOD devices following recovery format to make the device
  usable if it was originally in an unsupported sector size.
  - Display correct adapter serial number in iprconfig.
  - Support for microcode download to new adapters.
  - Support for iSeries disk microcode update using microcode images
  from the pSeries microcode website.
* Fri Jun 11 2004 - meissner@suse.de
- update to version 2.0.12
  - Fix bug preventing ucode download to iSeries disks from working.
  LTC#9303/#41935
* Fri Jun 11 2004 - meissner@suse.de
- update to version 2.0.11
  - Fix segmentation fault in _sg_ioctl that was causing a silent
  failure of microcode update to disks. The microcode update would
  fail, but no error would be logged. The seg fault was in a child
  process, so the parent process kept running. #41905/LTC#9265
* Sun May 23 2004 - olh@suse.de
- update to version 2.0.10
  - Don't let iprdbg sg ioctls be retried. (#41045 - LTC8812)
  - Add --force flag to iprconfig to allow user to workaround buggy
  drive firmware. (#41043 - LTC8810)
  - Don't initialize read/write protected disks (#41044 - LTC8811)
  - Fix some reclaim cache bugs (#41042 - LTC8809)
  - Don't setup Mode Page 0x0A if test unit ready fails
  (#41041 - LTC8808)
* Mon May 03 2004 - olh@suse.de
- update to version 2.0.9
  - Add --debug option to all utilities
  - Make utilities behave better when ipr is not loaded
  - Fix dependencies in init.d scripts
  - Don't log an error if ipr is not loaded
* Thu Apr 29 2004 - olh@suse.de
- update to version 2.0.8
  - Fix memory leak in code download path
  - Increase size of page 0 inquiry buffer so that extended vpd is
  displayed
  - Decrease write buffer timeout to 2 minutes
  enable rcscripts iprdump, iprinit, iprupdate per default on ppc
  (#39612 - LTC7898)
* Fri Apr 16 2004 - olh@suse.de
- update to version 2.0.7
  - Load sg module in init.d scripts if not loaded
  - Load sg module in iprconfig if not loaded
* Thu Apr 15 2004 - olh@suse.de
- update to version 2.0.6
  - Battery maintenance fixes.
  - Fix to properly display failed status for pulled physical disks.
  - Battery maintenance fixes.
  - Fix init.d scripts to work properly with yast runlevel editor.
  - Fix device details screen in iprconfig for Failed array members
  - Allow formatting devices even if qerr cannot be disabled
* Tue Mar 30 2004 - olh@suse.de
- update to version 2.0.4
* Fri Mar 19 2004 - olh@suse.de
- do not enable daemons per default, needs a different solution
* Sun Mar 14 2004 - olh@suse.de
- initial package with version 2.0.2
